﻿using System.Drawing;
using System.Drawing.Drawing2D;

using DevExpress.XtraEditors;
using DevExpress.XtraGrid.Views.Base;
using DevExpress.XtraGrid.Views.Card;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.cardView.OptionsBehavior.AutoPopulateColumns = true;

            this.gridControl.DataSource = new nwindDataSetTableAdapters.ProductsTableAdapter().GetData();

            this.cardView.CustomDrawCardFieldCaption += cardView_CustomDrawCardFieldCaption;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 카드 뷰 카드 필드 제목 커스텀 그리기 - cardView_CustomDrawCardFieldCaption(sender, e)

        /// <summary>
        /// 카드 뷰 카드 필드 제목 커스텀 그리기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void cardView_CustomDrawCardFieldCaption(object sender, RowCellCustomDrawEventArgs e)
        {
            CardView cardView = sender as CardView;

            bool isFocusedFieldAndCard = false;

            if(cardView.FocusedColumn != null)
            {
                isFocusedFieldAndCard = e.Column.AbsoluteIndex == cardView.FocusedColumn.AbsoluteIndex &&
                                        e.RowHandle == cardView.FocusedRowHandle;
            }

            Brush backgroundBrush;

            Color color1 = Color.FromArgb(240, 240, 240);
            Color color2 = Color.FromArgb(166, 166, 166);

            if(isFocusedFieldAndCard)
            {
                backgroundBrush = e.Cache.GetGradientBrush(e.Bounds, color1, color2, LinearGradientMode.Horizontal); 
            }
            else
            {
                backgroundBrush = e.Cache.GetGradientBrush(e.Bounds, color2, color1, LinearGradientMode.Horizontal);
            }

            e.Cache.FillRectangle(backgroundBrush, e.Bounds);

            e.Appearance.DrawString(e.Cache, e.DisplayText, e.Bounds);

            e.Handled = true;
        }

        #endregion
    }
}